// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from 'vue';
import 'vant/lib/index.css';
import { Picker } from "vant";
import { Icon } from "vant";
import { Popup } from "vant";

Vue.use(Popup);
Vue.use(Icon);
Vue.use(Picker);
import Calendar from './components/cal.vue'
import eventBus from '../../../../../../util/eventBus'
(function (KDApi) {
  function MyComponent (model) {
    this._setModel(model)
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model
    },
    init: function (props) {
      console.log('-----calenderKy', props)
      setHtml(this.model, props)
    },
    update: function (props) {
      console.log('-----updateCalenderKy', this.model, props)
      eventBus.pub(this.model, 'updateCalenderKy', props)
      // updateHtml(this.model, props)
    },
    destoryed: function () {
      console.log('-----destoryed11', this.model)
    }
  }

  const setHtml = (model, props) => {
    const { invoke } = model
    const {dateList,type,commitList,uncommitList} = props.data ? props.data : []
    // const dateList = [];
    // const type= 'dailySelect';
    // const commitList = ["2024-12-17","2024-12-16","2024-12-11","2024-12-20"];
    // const uncommitList=["2024-12-15","2024-12-14","2024-12-13","2024-12-12"];
    KDApi.loadFile('./css/index.css', model, () => {
      // console.log("22222",dateList)
      new Vue({
        el: model.dom,
        template:'<Calendar :type="type" :chooseData="commitList" :uncommitList="uncommitList" v-on:changeTime="changeTime" v-on:selectData="selectData"/>',
       components: {
          Calendar
        },
        data:function (){
          return {
            list:dateList,
            commitList:commitList,
            uncommitList:uncommitList,
            type:type
          }
        },
        mounted () {
          const self = this
          this.updateSub = eventBus.sub(model, 'updateCalenderKy', (props) => {
            const { dateList,commitList,uncommitList,type } = props.data ? props.data : []
            console.log("updatecalenderKy",dateList,commitList,uncommitList)
            self.type = type
            self.list = commitList
            self.commitList = commitList
            self.uncommitList = uncommitList
          })
        },
        destroyed () {
          eventBus.unsub(this.updateSub)
        },
        methods: {
          invoke: function (eventName, args) {
            invoke(eventName, args)
          },
          selectData:function(data){
            console.log("type",this.type)
            console.log("data",data)
            if(this.type == 'dailyOnlyRead'){
              this.invoke("selectDailyData",data)
            }else if(this.type == 'dailySelect'){
              this.invoke("dailySelectData",data)
            }else{
              this.invoke("selectData",data)
            }
           
          },
          changeTime(data){
            console.log("data",data)
            this.invoke("calendarArrows",data)
          }
        }
      })
    })
  }
  
  // 注册自定义组件
  KDApi.register('calenderKy', MyComponent)
})(window.KDApi)
